<template>
  <div id="tags-view-container" class="tags-view-container">
    <div id="getviews">
      <div class="alltags" v-if="visitedViews.length > 0">
        <div class="imgs" @click="closeall">
          <img src="@/assets/images/all.png" v-if="!showall" />
          <img src="@/assets/images/all_on.png" v-if="showall" />
          <!--<i class="el-icon-arrow-down" v-if="!showall"></i> <i class="el-icon-arrow-up" v-if="showall"></i>-->
        </div>
        <el-collapse-transition>
          <div class="tagslist" :class="{'noshow':!showall}">
            <router-link v-for="(tag, index) in visitedViews" ref="tag" :key="tag.fullPath" :class="isActive(tag)?'active':''"
              :to="{ path: tag.fullPath, query: tag.query, fullPath: tag.fullPath }" tag="span" class="tags-view-item"
              @contextmenu.prevent.native="openMenu(tag,$event)">
              <div @click="changetags">
                <i class="el-icon-check"></i>
                <span :id="isActive(tag)?'tagTitles':''">{{ tag.title }}</span>
              </div>
            </router-link>
            <div class="clasall" @click="closeAllTag(selectedTag)">关闭全部标签</div>
          </div>
        </el-collapse-transition>
      </div>
      <scroll-pane ref="scrollPane" class="tags-view-wrapper" @scroll="handleScroll">
        <draggable v-model="visitedViews" :options="dragOptions" @end="end">
          <router-link v-for="(tag, index) in visitedViews" ref="tag" :key="tag.fullPath" :class="isActive(tag)?'active':''"
            :to="{ path: tag.fullPath, query: tag.query, fullPath: tag.fullPath }" tag="span" class="tags-view-item"
            @click.middle.native="!isAffix(tag)?closeSelectedTag(tag):''" @contextmenu.prevent.native="openMenu(tag,$event)">
            <!--<svg :class="isActive(tag)?'tags-icon tags-icon-active':'tags-icon'" aria-hidden="true">-->
              <!--<use :xlink:href="iconName(tag)" />-->
            <!--</svg>-->
            <span :id="isActive(tag)?'tagTitle':''">{{ tag.title.replace(/<[^>]+>/g, '') }}</span>
            <span v-if="!isAffix(tag)" class="el-icon-close" @click.prevent.stop="closeSelectedTag(tag)" />
            <i
              :class="index!=visitedViews.length-1 && index != isActiveIndex() && index != isActiveIndex()-1?'tags-item-line':'tags-item-line item-color'" />
          </router-link>
        </draggable>
      </scroll-pane>
      <ul v-show="visible" :style="{left:left+'px',top:top+'px'}" class="contextmenu">
        <li @click="refreshSelectedTag(selectedTag)"><i class="el-icon-refresh-right"></i> 刷新页面</li>
        <li v-if="!isAffix(selectedTag)" @click="closeSelectedTag(selectedTag)"><i class="el-icon-close"></i> 关闭当前</li>
        <li @click="closeOthersTags"><i class="el-icon-circle-close"></i> 关闭其他</li>
        <li v-if="!isFirstView()" @click="closeLeftTags"><i class="el-icon-back"></i> 关闭左侧</li>
        <li v-if="!isLastView()" @click="closeRightTags"><i class="el-icon-right"></i> 关闭右侧</li>
        <li @click="closeAllTags(selectedTag)"><i class="el-icon-circle-close"></i> 全部关闭</li>
      </ul>
    </div>
  </div>
</template>

<script>
import draggable from 'vuedraggable';
import ScrollPane from './ScrollPane';
import path from 'path';

export default {
  components: { ScrollPane, draggable },
  data() {
    return {
      visible: false,
      top: 0,
      left: 0,
      selectedTag: {},
      affixTags: [],
      showall: false,
      dragOptions: {
        animation: 200, // 动画时间，单位毫秒
        group: 'items', // 分组，同一分组内的元素可以互相拖拽
        ghostClass: 'ghost', // 拖拽过程中占位元素的class名称
        sort: true, // 是否启用排序功能
        draggable: '.tags-view-item', // 可拖拽元素的选择器
      }
    };
  },
  computed: {
    visitedViews() {
      return this.$store.state.tagsView.visitedViews;
    },
    iconName() {
      return function (val) {
        let svgIcon = val.meta && val.meta.icon, currentIcon = '';
        let icon = this.isActive(val) ? svgIcon + 'Tags' : svgIcon + 'Tag';
        if (!svgIcon) {
          const index = val.path.indexOf('/', val.path.indexOf('/') + 1);
          const parentPath = val.path.slice(0, index);
          const currentRoute = this.$router.options.routes.find(item => item.path === parentPath);
          if (currentRoute) {
            currentIcon = currentRoute.meta && currentRoute.meta.icon;
            icon = this.isActive(val) ? currentIcon + 'Tags' : currentIcon + 'Tag';
          }
        }
        icon = (svgIcon && svgIcon != '#') || (currentIcon && svgIcon != '#') ? icon : this.isActive(val) ? 'defaultTags' : 'defaultTag';
        return `#icon-${icon}`;
      };
    },
    routes() {
      return this.$store.state.permission.routes;
    },
    theme() {
      return this.$store.state.settings.theme;
    }
  },
  watch: {
    $route() {
      this.addTags();
      this.moveToCurrentTag();
      this.getviews();
    },
    visible(value) {
      if (value) {
        document.body.addEventListener('click', this.closeMenu);
      } else {
        document.body.removeEventListener('click', this.closeMenu);
      }
    },
  },
  created() {
    this.$nextTick(() => {
      this.initTags();
      this.addTags();
    });
  },
  methods: {
    getviews() {
      let viewlist = [];
      let views = this.$store.state.tagsView.visitedViews;
      views.forEach(view => {
        let li = {};
        li.fullPath = view.fullPath;
        li.hash = view.hash;
        li.meta = view.meta;
        li.name = view.name;
        li.params = view.params;
        li.path = view.path;
        li.query = view.query;
        li.title = view.title;
        // li.matched = view.matched //此条数据放出会报错
        viewlist.push(li);
      });
      sessionStorage.setItem("views", JSON.stringify(viewlist));
    },
    changetags() {
      this.showall = false;
    },
    closeall() {
      if (this.showall == true) {
        this.showall = false;
      } else {
        this.showall = true;
      }
    },
    isActive(route) {
      return route.fullPath == this.$route.fullPath;
    },
    isAffix(tag) {
      return tag.meta && tag.meta.affix;
    },
    isActiveIndex() {
      const idx = this.visitedViews.findIndex(item => item.fullPath === this.$route.fullPath) || 0;
      return idx;
    },
    isFirstView() {
      try {
        return this.selectedTag.fullPath === '/index' || this.selectedTag.fullPath === this.visitedViews[1].fullPath;
      } catch (err) {
        return false;
      }
    },
    isLastView() {
      try {
        return this.selectedTag.fullPath === this.visitedViews[this.visitedViews.length - 1].fullPath;
      } catch (err) {
        return false;
      }
    },
    filterAffixTags(routes, basePath = '/') {
      let tags = [];
      routes.forEach(route => {
        if (route.meta && route.meta.affix) {
          const tagPath = path.resolve(basePath, route.path);
          tags.push({
            fullPath: tagPath,
            path: tagPath,
            name: route.name,
            meta: { ...route.meta }
          });
        }
        if (route.children) {
          const tempTags = this.filterAffixTags(route.children, route.fullPath);
          if (tempTags.length >= 1) {
            tags = [...tags, ...tempTags];
          }
        }
      });
      return tags;
    },
    initTags() {
      const affixTags = this.affixTags = this.filterAffixTags(this.routes);
      for (const tag of affixTags) {
        // Must have tag name
        if (tag.name) {
          this.$store.dispatch('tagsView/addVisitedView', tag);
        }
      }
    },
    addTags() {
      const { name } = this.$route;
      if (name) {
        this.$store.dispatch('tagsView/addView', this.$route);
        if (this.$route.meta.link) {
          this.$store.dispatch('tagsView/addIframeView', this.$route);
        }
      }
      return false;
    },
    moveToCurrentTag() {
      const tags = this.$refs.tag;
      this.$nextTick(() => {
        for (const tag of tags) {
          if (tag.to.fullPath === this.$route.fullPath) {
            this.$refs.scrollPane.moveToTarget(tag);
            // when query is different then update
            if (tag.to.fullPath !== this.$route.fullPath) {
              this.$store.dispatch('tagsView/updateVisitedView', this.$route);
            }
            break;
          }
        }
      });
    },
    refreshSelectedTag(view) {
      this.$tab.refreshPage(view);
      if (this.$route.meta.link) {
        this.$store.dispatch('tagsView/delIframeView', this.$route);
      }
    },
    closeSelectedTag(view) {
      this.$tab.closePage(view).then(({ visitedViews }) => {
        if (this.isActive(view)) {
          this.toLastView(visitedViews, view);
        }
      });
    },
    closeRightTags() {
      this.$tab.closeRightPage(this.selectedTag).then(visitedViews => {
        if (!visitedViews.find(i => i.fullPath === this.$route.fullPath)) {
          this.toLastView(visitedViews);
        }
      });
    },
    closeLeftTags() {
      this.$tab.closeLeftPage(this.selectedTag).then(visitedViews => {
        if (!visitedViews.find(i => i.fullPath === this.$route.fullPath)) {
          this.toLastView(visitedViews);
        }
      });
    },
    closeOthersTags() {
      this.$router.push(this.selectedTag.fullPath).catch(() => { });
      this.$tab.closeOtherPage(this.selectedTag).then(() => {
        this.moveToCurrentTag();
      });
    },
    closeAllTag(view) {
      this.$nextTick(() => {
        this.showall = false;
        this.closeAllTags(view);
      });
    },
    closeAllTags(view) {
      this.$tab.closeAllPage().then(({ visitedViews }) => {
        if (this.affixTags.some(tag => tag.fullPath === this.$route.fullPath)) {
          return;
        }
        this.toLastView(visitedViews, view);
      });
    },
    toLastView(visitedViews, view) {
      const latestView = visitedViews.slice(-1)[0];
      if (latestView) {
        this.$router.push(latestView.fullPath);
      } else {
        // now the default is to redirect to the home page if there is no tags-view,
        // you can adjust it according to your needs.
        if (view.name === 'Dashboard') {
          // to reload home page
          this.$router.replace({ path: '/redirect' + view.fullPath });
        } else {
          this.$router.push('/');
        }
      }
    },
    openMenu(tag, e) {
      const menuMinWidth = 105;
      const offsetLeft = this.$el.getBoundingClientRect().left; // container margin left
      const offsetWidth = this.$el.offsetWidth; // container width
      const maxLeft = offsetWidth - menuMinWidth; // left boundary
      const left = e.clientX - offsetLeft + 15; // 15: margin right

      if (left > maxLeft) {
        this.left = maxLeft;
      } else {
        this.left = left;
      }

      this.top = e.clientY;
      this.visible = true;
      this.selectedTag = tag;
    },
    closeMenu() {
      this.visible = false;
    },
    handleScroll() {
      this.closeMenu();
    },
    end(event) {
      //调换顺序
      let oldIndex = event.oldIndex;//移动初始位置
      let newIndex = event.newIndex;//运动终止位置
      let diff = Math.abs(newIndex - oldIndex);//插值绝对值
      let index = this.visitedViews[oldIndex];
      if (eval(oldIndex) > eval(newIndex)) {
        for (let i = 0; i < diff; i++) {
          this.visitedViews[oldIndex - i] = this.visitedViews[oldIndex - i - 1];
        }
        this.visitedViews[newIndex] = index;
      } else {
        for (let i = 0; i < diff; i++) {
          this.visitedViews[oldIndex + i] = this.visitedViews[oldIndex + i + 1];
        }
        this.visitedViews[newIndex] = index;
      }
      this.$forceUpdate();
    },
  }
}
</script>

<style lang="scss" scoped>
.tags-view-container {
  height: 56px;
  width: 100%;
  background: #fff;
  position: relative;
  ::v-deep .el-scrollbar__wrap {
    margin-left: 64px;
  }
  .tags-view-wrapper {
    .tags-view-item {
      display: inline-block;
      position: relative;
      cursor: pointer;
      min-width: 128px;
      height: 32px;
      line-height: 32px;
      color: #495060;
      background: #fff;
      padding: 0 20px 0 8px;
      font-size: 12px;
      .tags-icon {
        width: 16px;
        height: 16px;
        fill: currentColor;
        color: #5a5e66;
        margin: 8px 4px -3px 4px;
        &.tags-icon-active {
          color: pink;
        }
      }
      .tags-item-line {
        display: block;
        width: 1px;
        height: 24px;
        background: #d0d1d9;
        position: absolute;
        right: 0;
        top: 4px;
        z-index: 2;
        &.item-color {
          background: #ffffff;
        }
      }
      /*&:first-of-type {*/
      /*margin-left: 64px;*/
      /*}*/
      &:hover {
        .el-icon-close {
          background-color: rgba(153, 153, 153, 0.3);
          color: #999999;
        }
      }
      &.active {
        background-color: #f5f5f5;
        color: #232323;
        border-top-left-radius: 10px;
        border-top-right-radius: 10px;
        &:hover {
          .el-icon-close {
            background-color: initial;
            color: initial;
          }
        }
      }
    }
  }
  .contextmenu {
    margin: 0;
    background: #fff;
    z-index: 3000;
    position: absolute;
    list-style-type: none;
    padding: 5px 0;
    border-radius: 4px;
    font-size: 12px;
    font-weight: 400;
    color: #333;
    box-shadow: 2px 2px 3px 0 rgba(0, 0, 0, 0.3);
    li {
      margin: 0;
      padding: 7px 16px;
      cursor: pointer;
      &:hover {
        background: #eee;
      }
    }
  }
  .alltags {
    position: absolute;
    align-items: center;
    justify-content: center;
    width: 24px;
    height: 24px;
    left: 24px;
    top: 28px;
    cursor: pointer;
    text-align: center;
    z-index: 10;
    &::after {
      content: " ";
      position: absolute;
      border-right: 1px solid #efefef;
      height: 18px;
      width: 0;
      top: 3px;
      right: -8px;
    }
    .imgs > img {
      width: 24px;
      height: 24px;
    }
    .tagslist {
      transition: all 0.2s;
      display: block;
      position: absolute;
      left: 0;
      top: 32px;
      background-color: #fcfcfc;
      color: #141414;
      font-size: 13px;
      line-height: 1em;
      margin-bottom: 0;
      max-height: 450px;
      /*overflow-y: auto;*/
      overflow-y: overlay;
      padding: 8px 0 0;
      width: 146px;
      text-align: left;
      border-radius: 4px;
      box-shadow: 0 2px 9px 2px rgba(0, 0, 0, 0.09),
        0 1px 2px -2px rgba(0, 0, 0, 0.16);
      .tags-view-item {
        display: block;
        position: relative;
        > div {
          padding: 8px 8px 8px 32px;
          line-height: 20px;
          white-space: nowrap;
          text-overflow: ellipsis;
          overflow: hidden;
        }
        &:hover {
          background: rgba(0, 0, 0, 0.04);
        }
        .el-icon-check {
          display: none;
          position: absolute;
          left: 8px;
          width: 16px;
          font-size: 16px;
        }
        &.active {
          background: rgba(0, 129, 255, 0.04);
          .el-icon-check {
            display: block;
            color: #0081ff;
          }
        }
      }
      .clasall {
        border-top: 1px solid #efefef;
        padding: 10px 32px;
        line-height: 20px;
        color: #ff3c3c;
        &:hover {
          background: #ffece8;
        }
      }
    }
    .noshow {
      display: none;
      opacity: 0;
      /*height: 0;*/
    }
  }
}
</style>

<style lang="scss">
//reset element css of el-icon-close
.tags-view-wrapper {
  .tags-view-item {
    .el-icon-close {
      position: absolute;
      right: 5px;
      top: 8px;
      width: 16px;
      height: 16px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);
      transform-origin: 100% 50%;
      &:before {
        transform: scale(0.95);
        display: inline-block;
        vertical-align: -2.5px;
      }
    }
  }
}
</style>
